POJ 3009

2024-05-09 15:38
文章标签 poj 3009

本文主要是介绍POJ 3009,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

题目链接:http://poj.org/problem?id=3009


题目大意:在一个矩形游戏盘上,有石头,冰球,终点,起点。规则:上下左右抛出冰球,且抛出后除非碰到石头或终点,否则不停止。如果出界或者连续抛出10次以上就算失败。另外,冰球不能从紧挨着石头的一方抛出;一旦冰球碰到石头,则立即停止,石头消失,然后可以进行下一次抛出。


题目的思路是深度优先遍历,但是做了两晚也没做出来,参考网上的AC代码后,发现自己的思路是有问题。总结如下:

1. 一个最致命的问题是两个函数的返回值所表达的意思是相同的,这一定预示着程序的失败。

        2. 搜索的深度就是抛出的次数。


代码如下:


<span style="font-size:18px;">#include<stdio.h>
const int HMAX = 25;
const int WMAX = 25;
int res;
int graph[HMAX][WMAX];
int W, H, istart, jstart;
int hoff[4] = { -1, 1, 0 , 0};
int woff[4] = { 0, 0, -1, 1};
void init(){
<span style="white-space:pre">	</span>res = 2000;
<span style="white-space:pre">	</span>scanf("%d%d", &W, &H);
<span style="white-space:pre">	</span>for(int i = 0; i < H; i++){
<span style="white-space:pre">		</span>for(int j = 0; j < W; j++){
<span style="white-space:pre">			</span>scanf("%d", &graph[i][j]);
<span style="white-space:pre">			</span>if(graph[i][j] == 2){
<span style="white-space:pre">				</span>istart = i;
<span style="white-space:pre">				</span>jstart = j;
<span style="white-space:pre">				</span>graph[i][j] = 0;
<span style="white-space:pre">			</span>}
<span style="white-space:pre">		</span>}
<span style="white-space:pre">	</span>}
<span style="white-space:pre">	</span>return ;
}
void minFindGoal(int is, int js, int depth){
<span style="white-space:pre">	</span>if( depth > 10 || depth >= res ) return;  //剪枝:减掉与现有结果相同或者更大的可能情况,效果:从163ms到63ms
<span style="white-space:pre">	</span>
<span style="white-space:pre">	</span>for(int k = 0; k < 4; k++){
<span style="white-space:pre">		</span>if( graph[is+hoff[k]][js+woff[k]] == 1 ) continue;
<span style="white-space:pre">		</span>int i, j;
<span style="white-space:pre">		</span>for( i = is + hoff[k], j = js + woff[k]; 0 <= i && i < H && 0 <= j && j < W && graph[i][j] == 0; i += hoff[k], j += woff[k] ){;}
<span style="white-space:pre">		</span>if( i < 0 || i >= H || j < 0 || j>= W ){
<span style="white-space:pre">			</span>continue;
<span style="white-space:pre">		</span>}
<span style="white-space:pre">		</span>if(graph[i][j] == 3){
<span style="white-space:pre">			</span>res = res < depth ? res: depth;
<span style="white-space:pre">			</span>break;                                     //剪枝:如果找到,其余方向只能是大于等于它
<span style="white-space:pre">		</span>}
<span style="white-space:pre">		</span>graph[i][j] = 0;
<span style="white-space:pre">		</span>minFindGoal(i-hoff[k], j-woff[k], depth + 1);
<span style="white-space:pre">		</span>graph[i][j] = 1;
<span style="white-space:pre">	</span>}
<span style="white-space:pre">	</span>
<span style="white-space:pre">	</span>return;
}
int main()
{
<span style="white-space:pre">	</span>while(1){
<span style="white-space:pre">		</span>init();
<span style="white-space:pre">		</span>if( W == 0 && H == 0 ) break; 
<span style="white-space:pre">		</span>minFindGoal(istart, jstart, 1);
<span style="white-space:pre">		</span>if( res < 2000 )
<span style="white-space:pre">			</span>printf("%d\n", res);
<span style="white-space:pre">		</span>else
<span style="white-space:pre">			</span>printf("%d\n", -1);
<span style="white-space:pre">	</span>}
<span style="white-space:pre">	</span>return 0;
}</span>


这篇关于POJ 3009的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/973796

相关文章

poj 3974 and hdu 3068 最长回文串的O(n)解法(Manacher算法)

求一段字符串中的最长回文串。 因为数据量比较大,用原来的O(n^2)会爆。 小白上的O(n^2)解法代码:TLE啦~ #include<stdio.h>#include<string.h>const int Maxn = 1000000;char s[Maxn];int main(){char e[] = {"END"};while(scanf("%s", s) != EO

hdu 2602 and poj 3624(01背包)

01背包的模板题。 hdu2602代码: #include<stdio.h>#include<string.h>const int MaxN = 1001;int max(int a, int b){return a > b ? a : b;}int w[MaxN];int v[MaxN];int dp[MaxN];int main(){int T;int N, V;s

poj 1511 Invitation Cards(spfa最短路)

题意是给你点与点之间的距离,求来回到点1的最短路中的边权和。 因为边很大,不能用原来的dijkstra什么的,所以用spfa来做。并且注意要用long long int 来存储。 稍微改了一下学长的模板。 stack stl 实现代码: #include<stdio.h>#include<stack>using namespace std;const int M

poj 3259 uva 558 Wormholes(bellman最短路负权回路判断)

poj 3259: 题意:John的农场里n块地,m条路连接两块地,w个虫洞,虫洞是一条单向路,不但会把你传送到目的地,而且时间会倒退Ts。 任务是求你会不会在从某块地出发后又回来,看到了离开之前的自己。 判断树中是否存在负权回路就ok了。 bellman代码: #include<stdio.h>const int MaxN = 501;//农场数const int

poj 1258 Agri-Net(最小生成树模板代码)

感觉用这题来当模板更适合。 题意就是给你邻接矩阵求最小生成树啦。~ prim代码:效率很高。172k...0ms。 #include<stdio.h>#include<algorithm>using namespace std;const int MaxN = 101;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int n

poj 1287 Networking(prim or kruscal最小生成树)

题意给你点与点间距离,求最小生成树。 注意点是,两点之间可能有不同的路,输入的时候选择最小的,和之前有道最短路WA的题目类似。 prim代码: #include<stdio.h>const int MaxN = 51;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int P;int prim(){bool vis[MaxN];

poj 2349 Arctic Network uva 10369(prim or kruscal最小生成树)

题目很麻烦,因为不熟悉最小生成树的算法调试了好久。 感觉网上的题目解释都没说得很清楚,不适合新手。自己写一个。 题意:给你点的坐标,然后两点间可以有两种方式来通信:第一种是卫星通信,第二种是无线电通信。 卫星通信:任何两个有卫星频道的点间都可以直接建立连接,与点间的距离无关; 无线电通信:两个点之间的距离不能超过D,无线电收发器的功率越大,D越大,越昂贵。 计算无线电收发器D

poj 1502 MPI Maelstrom(单源最短路dijkstra)

题目真是长得头疼,好多生词,给跪。 没啥好说的,英语大水逼。 借助字典尝试翻译了一下,水逼直译求不喷 Description: BIT他们的超级计算机最近交货了。(定语秀了一堆词汇那就省略吧再见) Valentine McKee的研究顾问Jack Swigert,要她来测试一下这个系统。 Valentine告诉Swigert:“因为阿波罗是一个分布式共享内存的机器,所以它的内存访问

uva 10061 How many zero's and how many digits ?(不同进制阶乘末尾几个0)+poj 1401

题意是求在base进制下的 n!的结果有几位数,末尾有几个0。 想起刚开始的时候做的一道10进制下的n阶乘末尾有几个零,以及之前有做过的一道n阶乘的位数。 当时都是在10进制下的。 10进制下的做法是: 1. n阶位数:直接 lg(n!)就是得数的位数。 2. n阶末尾0的个数:由于2 * 5 将会在得数中以0的形式存在,所以计算2或者计算5,由于因子中出现5必然出现2,所以直接一

poj 3159 (spfa差分约束最短路) poj 1201

poj 3159: 题意: 每次给出b比a多不多于c个糖果,求n最多比1多多少个糖果。 解析: 差分约束。 这个博客讲差分约束讲的比较好: http://www.cnblogs.com/void/archive/2011/08/26/2153928.html 套个spfa。 代码: #include <iostream>#include <cstdio>#i